﻿using System;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;

namespace CartInSupermarket
{
    internal class Program
    {
        private static void Main()
        {
            var s = File.ReadAllLines("prsis.txt");
            var limit = int.Parse(s[0]);
            var sequences = s.Skip(2).Select(int.Parse).ToArray();
            Debug.Assert(sequences.Length == int.Parse(s[1]));
            int low = 1, high = (int) 1e9;
            while (low < high)
            {
                var mid = (low + high)/2;
                var need = sequences.Sum(x =>
                {
                    int low1 = 0, high1 = x;
                    while (low1 < high1)
                    {
                        int mid1 = (low1 + high1)/2, numCarts = x, numSplits = mid1, time = 0, numParts = 1;
                        while (numParts <= numSplits)
                        {
                            numSplits -= numParts;
                            numParts *= 2;
                            ++time;
                        }
                        numCarts = Math.Max(0, numCarts - (numParts - numSplits));
                        var extra = numParts + numSplits;
                        if ((time + 1) + (numCarts + extra - 1)/extra <= mid) high1 = mid1;
                        else low1 = mid1 + 1;
                    }
                    return (long) (low1 == x ? int.MaxValue : low1);
                });
                if (need <= limit) high = mid;
                else low = mid + 1;
            }
            File.WriteAllText("prval.txt", low.ToString(CultureInfo.InvariantCulture));
        }
    }
}