#include <cstdio>
#include <vector>
#include <iostream>
#include <cassert>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<int, pii> edge;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<edge> e;
    long long sumE = 0;
    long long sumT = 0;

    for (int i = 0; i < m + k; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        e.push_back( make_pair(c, make_pair(x, y)) );
        if (i < m) sumE += c;
    }

    sort(e.begin(), e.end());
    vector<int> color(n + 1); for (int i = 0; i <= n; ++i) color[i] = i;
    vector<vi> vert(n + 1); for (int i = 0; i <= n; ++i) vert[i].push_back(i);

    for (int i = 0; i < m + k; ++i) {
        if (color[e[i].second.first] != color[e[i].second.second]) {
            sumT += e[i].first;
            int x = e[i].second.first;
            int y = e[i].second.second;

            if (vert[color[x]].size() < vert[color[y]].size()) swap(x, y);

            int _col = color[y];
            for (int j = 0; j < (int)vert[_col].size(); ++j) {
                color[vert[_col][j]] = color[x];
                vert[color[x]].push_back(vert[_col][j]);
            }

            vi tmp;
            vert[_col].swap(tmp);
        }
    }

    cout << max(0LL, sumT - sumE) << endl;
}

int main() {
    cin.sync_with_stdio(false);

    freopen("rssis.txt", "r", stdin);
    freopen("rsval.txt", "w", stdout);

    solve();

    return 0;
}
